/*-------------------------------------------------------*
 * BOX.H:  Copyright (c) 1987, Allen I. Holub.
 *                  All rights reserved.
 *
 *  #defines for the box-drawing characters on the IBM PC.
 *
 *-------------------------------------------------------*
 *      The names are:
 *
 *      UL      Upper left corner
 *      UR      Upper right corner
 *      LL      lower left corner
 *      LR      lower right corner
 *      CEN     Center (intersection of two lines)
 *      TOP     Tee with the flat piece on top
 *      BOT     Bottom tee              
 *      LEFT    Left tee
 *      RIGHT   Right tee
 *      HORIZ   Horizontal line
 *      VERT    Vertical line.
 *
 *
 *                      UL    -TOP-     UR              HORIZ
 *                              |
 *                      L                R                V
 *                      E       |        I                E
 *                      F--   -CEN-    --G                R
 *                      T       |        H                T
 *                      |                T              
 *                              |
 *                      LL    -BOT-     LR
 *
 *
 * The D_XXX  defines have double horizontal and vertical lines
 * The HD_XXX defines have double horizontal lines only
 * The VD_XXX defines have double vertial lines only
 *
 * If your terminal is not IBM compatible, #define all of these
 * as '+', except for the VERT #defines, which should be a |,
 * and the HORIZ #defines, which should be a -.
 */

#define VERT            179
#define RIGHT           180
#define UR              191
#define LL              192
#define BOT             193
#define TOP             194
#define LEFT            195
#define HORIZ           196
#define CEN             197
#define LR              217
#define UL              218

#define D_VERT          186
#define D_RIGHT         185
#define D_UR            187
#define D_LL            200
#define D_BOT           202
#define D_TOP           203
#define D_LEFT          204
#define D_HORIZ         205
#define D_CEN           206
#define D_LR            188
#define D_UL            201

#define HD_VERT         179
#define HD_RIGHT        181
#define HD_UR           184
#define HD_LL           212
#define HD_BOT          207
#define HD_TOP          209
#define HD_LEFT         198
#define HD_HORIZ        205
#define HD_CEN          216
#define HD_LR           190
#define HD_UL           213

#define VD_VERT         186
#define VD_RIGHT        182
#define VD_UR           183
#define VD_LL           211
#define VD_BOT          208
#define VD_TOP          210
#define VD_LEFT         199
#define VD_HORIZ        196
#define VD_CEN          215
#define VD_LR           189
#define VD_UL           214

