extern	char	*ltos	(long, char*, int	);
extern	double	floor	(double			);
extern	double	ceil	(double			);

#define	MAXPREC	32			/* Maximum number of digits	*/
					/* permitted to the right of	*/
					/* the decimal point		*/
#define	FRACT(n) ((n)-(long)(n))	/* Extract fractional part of n	*/

#define	min(a,b) ((a) < (b) ? (a) : (b))

/*---------------------------------------------------------------------------*/

char	*dtos( num, buf, precision )
double 	num	;
char	*buf	;
int	precision;
{
	/* Convert double to string. Only decimal conversion is
	 *		supported.
	 * "Num"	is the number to be converted (must be positive).
	 * "buf"	is the output buffer
	 * "precision"	is the number of digits to the right of the
	 *		decimal. Maximum precision is 32. If precision is
	 *		zero, only the integer part of the number is
	 * 		converted
	 * The output string is null terminated and a pointer to
	 * the null terminator is returned.
	 */

	static	char	tbuf[MAXPREC+1];
	int		i	;
	char		*bp	;
	long		lnum	;
	
	precision = min(precision,MAXPREC);	/* Truncate the preci-	*/
						/* sion if necessary	*/
	if( num < 0.0 )		/* Convert number to positive	*/
	{			/* and print the '-' sign if	*/
		*buf++ = '-';	/* necessary			*/
		num = -num;
	}
	
	/* Strip off the integer part of the number and convert it 
	 * to an ASCII string using ltos. Then subtract the integer
	 * part from the original number to isolate the fraction.
	 */
	 
	buf = ltos( lnum = (long)num, buf, 10 );
	num -= lnum;
	
	if( precision )
	{
		/* Print the fraction. First multiply it by 10
		 * to the precision power to move it into the
		 * integer part of the number.
		 */
		 
		for( i = precision; --i >= 0 ; )
			num *= 10.0 ;
			
		/* Round the resulting integer number up or down as approp-
		 * riate, and then compute the number of leading
		 * required zeros in the resulting number as we call
		 * ltos( ). (ltos won't print the leading zeros.)
		 */
		 
		num = (FRACT(num) >= 0.50) ? ceil(num) : floor(num);
		
		i = precision - ( ltos((long)num, tbuf, 10) - tbuf);
		
		/* Finally transfer the decimal point, the leading
		 * zeros, and then the fractional part of the number,
		 * to the target buffer
		 */
		 
		for( *buf++ = '.'; --i >= 0; *buf++ = '0')
			;
			
		for( bp = tbuf; *bp; *buf++ = *bp++ )
			;
	}
	
	*buf = 0;
	return ( buf );
}

