char	*ltos( n, buf, base)
unsigned long	n	;
char		*buf	;
int		base	;
{
	/*	Convert long to string. Prints in hex, decimal, octal,
	 *						or binary.
	 *	"n"	is the number to be converted.
	 *	"buf"	is the output buffer.
	 *	"base"	is the base (16, 10, 8, or 2).
	 *
	 *	The output string is null terminated, and a pointer
	 *	to the null terminator is returned.
	 *
	 *	The number is put into an array one digit at a time
	 *	as it's translated. The array is filled with the digits
	 *	reversed (ie. the \0 goes in first, then the rightmost
	 *	digit, etc.) and then is reversed in place before
	 *	returning
	 */
	 
	register char	*bp	= buf;
	register int	minus	= 0;
	char		*endp;
	
	if( base == 10 && (long)n < 0 )	/* If the number is negative	*/
	{				/* and we're in base 10, set	*/
		minus++;		/* minus to true and make it	*/
		n = -( (long)n );	/* positive			*/
	}
	
	*bp = '\0';		/* We have to put the null in now	*/
				/* because the array is being 		*/
				/* filled in reverse order		*/
		
	do {
		*++bp = "0123456789abcdef" [ n % base ];
		n /= base;
	} while ( n );
	
	if ( minus )
		*++bp = '-';
		
	for ( endp = bp; bp > buf ;)	/* Reverse string in place	*/
	{
		minus = *bp;		/* Use minus for temporary	*/
		*bp -- = *buf;		/* storage			*/
		*buf++ = minus;
	}
	
	return endp;	/* Return pointer to terminating null		*/
}

