
/********************************************************************
 * C Users Group (U.K) C Source Code Library File CUGLIB.018        *
 * Inquiries to: M. Houston, 36 Whetstone Clo. Farquhar Rd.         *
 * Edgbaston, Birmingham B15 2QN ENGLAND			    *
 ********************************************************************
 * File name: libscn.c
 * Program name: libscn
 * Source of file: West Midlands OPUS BBS
 * Purpose: 
 *	This program scans Microsoft MSDOS .LIB files and reports the
 *	various modules and symbols defined/referenced therein.
 * Changes: <who what when & why major changes have been made>      
 ********************************************************************/

/* LIBSCN.C - jk - 01/06/86
 *
 *	This program scans Microsoft MSDOS .LIB files and reports the
 *	various modules and symbols defined/referenced therein.
 *
 *	It is based on OBJSCN.C, which reports much more data.
 */
#include "stdio.h"
#define TBLSIZ 200

FILE * fopen (), * Inf;

unsigned long NdxBeg, ftell();

int Chr, PgSz, Siz, Ni = 1, Ti = 1, Gi = 1, Si = 1, Pi = 1, Ei = 1;

char * donam (), * Name [ TBLSIZ ], * Seg [ 50 ],
     * Pub [ TBLSIZ ], * Ext [ TBLSIZ ];

main ( argc, argv ) int argc; char * argv [];
{ fprintf ( stderr, "\nLIBSCN Version 1.0 - 01-06-87\n" );
  Name [ 0 ] = Seg [ 0 ] = Pub [ 0 ] = Ext [ 0 ] = "none";
  if ( ! -- argc )
    { fprintf ( stderr, "\t USAGE: LIBSCN file1 file2 ...\n" );
      fprintf ( stderr, "\t\toutput, to stdout, may be redirected.\n" );
    }
  else
    while ( argc -- )
      {	if ( Inf = fopen ( * ++ argv, "rb" ))
	  { printf ( "\nFILE: %s\n", * argv );
 	    dofile ();
 	    printf ( "\n EOF: %s\n", * argv );
 	    fclose ( Inf );
	  }
 	else
 	  fprintf ( stderr, "FILE <%s> could not be opened\n", * argv );
      }
  exit ( 0 );
}

dofile ()
{ int n, gi, si;
  while (( Chr = getch ()) != EOF )
    { if ( Chr && ( Siz = getwd ()) > 0 )	/* skip over null fill */
	{ switch ( Chr )
	    {
	    case 0x80 :			/* THEADR	*/
	      Ni = Ti = Gi = Si = Pi = Ei = 1;
 	      printf ( "\nModule\t" );
 	      n = getch ();
 	      while ( n -- )
 		printf ( "%c", getch ());
 	      printf ( "\n" );
 	      break;

	    case 0x88 :         /* COMENT   */
	      docoment ();
	      continue;

	    case 0xf0 :         /* MS-Library header */
	      PgSz = Siz + 3;
	      NdxBeg = (unsigned) getwd ();       /* cast to prevent sign extension */
	      NdxBeg |= (unsigned long) ((unsigned) getwd ()) << 16;
	      n = getwd ();
	      printf ("MS-Library file - Index is at %lXh, %d block(s) of %d bytes\n",
		        NdxBeg, n, PgSz);
	      break;

 	    case 0x8A :			/* ENDMOD	*/
 	      printf ( "MODEND\t" );
	      while ( Siz )
		printf ( "%02x  ", getch ());
	      printf ( "\n" );
	      if (PgSz)
		{ skip ( (long) PgSz - ( ftell(Inf) % (long) PgSz));
		}
 	      break;

 	    case 0x8C :			/* EXTDEF	*/
	      while ( Siz > 1 )
		{ printf ( "     uses: " );
		  if (Ext[Ei])
		    free(Ext[Ei]);
		  Ext [ Ei ] = donam ();
		  printf ( "%s\n", Ext [ Ei ] );
		  getch ();
		}
 	      break;

 	    case 0x90 :			/* PUBDEF	*/
	      gi = getch ();
	      si = getch ();
	      if (!( gi || si ))
		getwd();
 	      while ( Siz > 1 )
		{ printf ( "  defines: " );
		  if (Pub[Pi])
		    free(Pub[Pi]);
 		  Pub [ Pi ] = donam ();
		  n = getwd ();
 		  printf ( "%s:%s\n", Seg [ si ], Pub [ Pi ] );
 		  getch ();
		}
 	      break;

 	    case 0x96 :			/* LNAMES	*/
 	      while ( Siz > 1 )
		{ if (Name[Ni])
		    free(Name[Ni]);
		  Name [ Ni ++ ] = donam ();
		}
 	      break;

 	    case 0x98 :			/* SEGDEF	*/
 	      while ( Siz > 1 )
		{ getch ();			/* read stuff from record	*/
		  getwd ();
		  si = getch ();
		  getch ();
		  getch ();
		  Seg [ Si ++ ] = Name [ si ];
		}
 	      break;

	    }
	  skip ((long)Siz);
	}
    }
}

skip(n) long n;
{ if (n)
  { fseek(Inf, n, 1);
    if (ftell(Inf) >= NdxBeg)
      fseek(Inf, 1L, 2);
  }
}

char * donam ()				/* copy name from record	*/
{ int n;
  char * t, * t1;
  n = getch ();				/* number of chars in name	*/
  t1 = t = alloc ( n + 1 );		/* get space for it		*/
  while ( n -- )
    * t ++ = getch ();		/* save the name for use	*/
  * t = 0;
  return ( t1 );
}

docoment ()			/* added per DC 01/04/86	*/
{   int class;
    int i;

    printf ( "COMENT\t" );
    getch ();                       /* comment type */
    switch ( class = getch () )     /* comment class */
        {
        case 0:                     /* Language translator comment */
            printf ("Compiler \"");
            while ( Siz > 1 )
                printf ( "%c", getch ());
            printf ("\"\n\t");
            break;

        case 159:                   /* default library search specification */
            printf ("DefLib\t\"");
            while ( Siz > 1 )
                printf ( "%c", getch ());
            printf ("\"\n\t");
            break;

        case 160:                       /* Dynamic link records (Import def)*/
            printf ("ImpDef\t");        /* for Windows/DOS 4 linker */
            getch ();
            i = getch ();
            printf ("\"%s\"\t", donam ());  /* Exported function name */
            printf ("\"%s\"", donam ());    /* Module name */
            if (i)
                printf (".%d", getwd ());   /* Function ordinal value */
            else
                getch ();                   /* skip a null */
            printf ("\n\t");
            break;
 
        default:
            printf ("Class=%d\n\t", class);
            while ( Siz )
                printf ( "%02x  ", getch ());
            printf ("\n");
            break;
        }
}

getch ()				/* get byte from Inf, polling	*/
{ poll ();
  -- Siz;
  return ( getc ( Inf ));
}

getwd ()				/* get word from Inf, polling	*/
{ poll ();
  Siz -= 2;
  return ( getw ( Inf ));
}

poll ()
{ if ( bdos ( 6, 255 ) == 3 )
    exit ( 7 );
}

/*---if your library doesn't have this, remove the comment-out frame
getw (f) FILE *f;
{ int x;
  x = EOF;
  fread(&x,2,f);
  return(x);
}
---*/

/* end of libscn.c */
